// Code generated by goa v3.12.3, DO NOT EDIT.
//
// task service
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/task/design

package task

import (
	"context"
)

// Task service provides endpoints to work with tasks.
type Service interface {
	// Create a task and put it in a queue for execution.
	Create(context.Context, *CreateTaskRequest) (res *CreateTaskResult, err error)
	// TaskResult retrieves task result from the Cache service.
	TaskResult(context.Context, *TaskResultRequest) (res any, err error)
}

// ServiceName is the name of the service as defined in the design. This is the
// same value that is set in the endpoint request contexts under the ServiceKey
// key.
const ServiceName = "task"

// MethodNames lists the service method names as defined in the design. These
// are the same values that are set in the endpoint request contexts under the
// MethodKey key.
var MethodNames = [2]string{"Create", "TaskResult"}

// CreateTaskRequest is the payload type of the task service Create method.
type CreateTaskRequest struct {
	// Task name.
	TaskName string
	// Data contains JSON payload that will be used for task execution.
	Data any
	// Cache key namespace.
	CacheNamespace *string
	// Cache key scope.
	CacheScope *string
}

// CreateTaskResult is the result type of the task service Create method.
type CreateTaskResult struct {
	// Unique task identifier.
	TaskID string
}

// TaskResultRequest is the payload type of the task service TaskResult method.
type TaskResultRequest struct {
	// Unique task identifier.
	TaskID string
}
